# ansible

![ansible](images/ansible.png "ansible")<!-- .element width="30%" -->


## ansible

* outil de
  * provisioning
  * gestion de config
  * déploiemenet d'application

* racheté par RedHat en octobre 2015

* outils équivalents
  * puppet, chief, salt ...


## ansible

* écrit en python
  * python 2 par défaut
  * marche bien en python 3
    * virtualenv


## ansible

* prérequis
  * sur la machine pilote (mgmt node)
    * ansible
  * sur le(s) noeud(s)
    * une connextion ssh ou PowerShell
    * python


## ansible

[![gestion ansible](images/ansible_mgmt.png "gestion ansible")](https://medium.com/formcept/configuration-management-and-continuous-deployment-cd0892dce998)


## terminologie

* **mgmt node** (machine pilote) machine surlaquelle ansible est installé et responsable de la configuration de toutes les machines gérées.
* **Inventory** (inventaire) fichier contenant les ip de tous les serveurs à configurer
* **Playbook** gère la configuration à déployer sur chaque serveur
* **Task** fichier où sont définies les actions réalisées par le playbook
* **Module** actions plus ou moins complexe utilisables à partir des **tasks**. ansible possède de [nombreux modules natifs](https://docs.ansible.com/ansible/latest/modules/modules_by_category.html). Il est possible d'écrire ses propres modules.
* **Role** permet d'organiser les playbooks en parties claires et réutilisables
* **Play** est l'exécution d'un playbook sur un serveur
* **Facts** information collectée par ansible sur le système du serveur à configurer
* **Handlers** similaire aux **tasks** mais appelable à partir d'une **task** (redémarrage de service par exemple)


ansible all --inventory-file=inventory.ini --module-name ping -u root

* modules

* task
  * register
  * debug
  * loop
  * set_fact
  * pre_task
* roles

* playbook
  * ligne de commande
  * --check --diff
  * verbosité
  * tags

* variable (see debug task)
  * hierarchie
  * from env ou Vault
  * acces dynamique
  * ansible-vault : utiliser vault
  * https://docs.ansible.com/ansible/latest/user_guide/playbooks_prompts.html
* plugin
  * callback
  * filter
  * lookup
* modules ansible utile
  * pexpect
* remote roles


* skeleton https://github.com/mrjk/ansible-skel

### Récupérer les roles nécessaires

* mettre à jour `requirements.yml` avec les rôles nécessaires

* récupérer les rôles

```
ansible-galaxy install -f -r requirements.yml -p ansible/roles/public
```
